//+------------------------------------------------------------------+
//|                                                   adxcrossEA.mq4 |
//|                        Copyright 2015, MetaQuotes Software Corp. |
//|                                             https://www.mql5.com |
//+------------------------------------------------------------------+
#property copyright "Copyright 2015, MetaQuotes Software Corp."
#property link      "https://www.mql5.com"
#property version   "1.00"
#property strict



extern string S1 = " --- EA Settings --- ";

///////put indicator settings here...../////

extern string TimeFrame       = "Current time frame";
extern int    AdxPeriod       = 14;

/////////////////////////////////////////////


extern   int        Magic = 1010;
extern   string     TradeComment = "ADX EA";

extern string S2="---------------- Money Management";

extern double Lotsize=1;//|-----------------------lots size
extern bool RiskMM=true;//|---------------------risk management
extern double RiskPercent=4;//|------------------risk percentage
extern int TP = 1000;
extern int SL = 200;
extern int MaxOrders=100;//|---------------------maximum orders allowed
extern bool Comments=true;//|--------------------allow comments on chart
extern int Slippage = 2 ;

extern string S5="---------------- Time Filter";

extern bool TradeOnSunday=false;//|---------------time filter on sunday
extern bool MondayToThursdayTimeFilter=true;//|-time filter the week
extern int MondayToThursdayStartHour=11;//|-------start hour time filter the week
extern int MondayToThursdayEndHour=19;//|--------end hour time filter the week
extern bool FridayTimeFilter=true;//|-----------time filter on friday
extern int FridayStartHour=11;//|-----------------start hour time filter on friday
extern int FridayEndHour=19;//|------------------end hour time filter on friday


extern string S6="---------------- Trailing Setttings";

extern int  TS = 1; // Stoploss follows behind current price by X pips
extern bool OnlyTrailProfits = true; // Trailing Stop will only trail when order is profitable
extern bool EnableTS = true;

extern string S16="---------------- Extras";

extern bool Hedge=false;//|----------------------enter an opposite trade
extern int HedgeSL=0;//|-------------------------stop loss
extern int HedgeTP=0;//|-------------------------take profit

extern string S17="---------------- Hide SL and TP";
extern bool HideSL=false;//|---------------------hide stop loss
extern bool HideTP=false;//|---------------------hide take profit



datetime PreviousBarTime1;
datetime PreviousBarTime2;

double maxEquity,minEquity,Balance=0.0;
double LotsFactor=1;
double InitialLotsFactor=1;
double TPP,OPP;
int Expire=0;

//+------------------------------------------------------------------+
//| expert start function                                            |
//+------------------------------------------------------------------+
int start() { 

//|---------risk management

   if(RiskMM)CalculateMM();

//|---------trailing stop

    trailingStopManager(TS,OnlyTrailProfits,EnableTS);

//|---------time filter

   if((TradeOnSunday==false&&DayOfWeek()==0)||(MondayToThursdayTimeFilter&&DayOfWeek()>=1&&DayOfWeek()<=4&&!(Hour()>=MondayToThursdayStartHour&&Hour()<MondayToThursdayEndHour))||(FridayTimeFilter&&DayOfWeek()==5&&!(Hour()>=FridayStartHour&&Hour()<FridayEndHour)))
   {
      CloseBuyOrders(Magic);
      CloseSellOrders(Magic);
      return(0);
   }

//////////
  double ArrowUp, ArrowDown;
  static int iBuyTicket=-1;
  static int iSellTicket=-1;
  
  // Get ADX Cross state
  ArrowUp = iCustom(NULL,0,"adxcrossmtf",TimeFrame,AdxPeriod,1,1);
  ArrowDown = iCustom(NULL,0,"adxcrossmtf",TimeFrame,AdxPeriod,0,1);
  
  // Open Buy order if current bar has arrow up signal
  if  (ArrowUp!=EMPTY_VALUE && iBuyTicket<0) {
    iBuyTicket=OrderSend(Symbol(), OP_BUY, Lotsize, Ask, 3,Ask - SL, Ask + TP,TradeComment, Magic, 0, Blue);   
  }
  // Open Sell order if current bar has arrow down signal
  if  (ArrowDown!=EMPTY_VALUE && iSellTicket<0) {
    iSellTicket=OrderSend(Symbol(), OP_SELL,Lotsize, Bid, 3, Bid + SL, Bid - TP ,TradeComment, Magic, 0, Red);    
  }
  
 
  return(0);
}

//------------------------------------------------------------
// function: dPips()
// Description: Convert a price difference to pips.
//-------------------------------------------------------------
double dPips(double dPrice1,double dPrice2,bool bAbs=false) {
  double dPipValue=(dPrice1-dPrice2)/Point; 
  if (bAbs) return( MathAbs(dPipValue));
  else return(dPipValue);
} 

//|---------close orders
    bool BUY=false;
    bool SELL=false;
 
   //|---------hidden sl-tp
   


//|---------not enough money warning

 



//|---------close buy orders

int CloseBuyOrders(int Magic)
{
  int total=OrdersTotal();

  for (int cnt=total-1;cnt>=0;cnt--)
  {
    OrderSelect(cnt,SELECT_BY_POS,MODE_TRADES);
    if(OrderMagicNumber()==Magic&&OrderSymbol()==Symbol())
    {
      if(OrderType()==OP_BUY)
      {
        OrderClose(OrderTicket(),OrderLots(),Bid,3);
      }
    }
  }
  return(0);
}

int CloseBuyOrdersHiddenTP(int Magic)
{
  int total=OrdersTotal();

  for (int cnt=total-1;cnt>=0;cnt--)
  {
    OrderSelect(cnt,SELECT_BY_POS,MODE_TRADES);
    if(OrderMagicNumber()==Magic&&OrderSymbol()==Symbol())
    {
      if(OrderType()==OP_BUY&&Bid>(OrderOpenPrice()+TP*Point))
      {
        OrderClose(OrderTicket(),OrderLots(),Bid,3);
      }
    }
  }
  return(0);
}

int CloseBuyOrdersHiddenSL(int Magic)
{
  int total=OrdersTotal();

  for (int cnt=total-1;cnt>=0;cnt--)
  {
    OrderSelect(cnt,SELECT_BY_POS,MODE_TRADES);
    if(OrderMagicNumber()==Magic&&OrderSymbol()==Symbol())
    {
      if(OrderType()==OP_BUY&&Bid<(OrderOpenPrice()-SL*Point))
      {
        OrderClose(OrderTicket(),OrderLots(),Bid,3);
      }
    }
  }
  return(0);
}

//|---------close sell orders

int CloseSellOrders(int Magic)
{
  int total=OrdersTotal();

  for(int cnt=total-1;cnt>=0;cnt--)
  {
    OrderSelect(cnt,SELECT_BY_POS,MODE_TRADES);
    if(OrderMagicNumber()==Magic&&OrderSymbol()==Symbol())
    {
      if(OrderType()==OP_SELL)
      {
        OrderClose(OrderTicket(),OrderLots(),Ask,3);
      }
    }
  }
  return(0);
}


int CloseSellOrdersHiddenTP(int Magic)
{
  int total=OrdersTotal();

  for(int cnt=total-1;cnt>=0;cnt--)
  {
    OrderSelect(cnt,SELECT_BY_POS,MODE_TRADES);
    if(OrderMagicNumber()==Magic&&OrderSymbol()==Symbol())
    {
      if(OrderType()==OP_SELL&&Ask<(OrderOpenPrice()-TP*Point))
      {
        OrderClose(OrderTicket(),OrderLots(),Ask,3);
      }
    }
  }
  return(0);
}

int CloseSellOrdersHiddenSL(int Magic)
{
  int total=OrdersTotal();

  for(int cnt=total-1;cnt>=0;cnt--)
  {
    OrderSelect(cnt,SELECT_BY_POS,MODE_TRADES);
    if(OrderMagicNumber()==Magic&&OrderSymbol()==Symbol())
    {
      if(OrderType()==OP_SELL&&Ask>(OrderOpenPrice()+SL*Point))
      {
        OrderClose(OrderTicket(),OrderLots(),Ask,3);
      }
    }
  }
  return(0);
}

//|---------count orders

int CountOrders(int Type,int Magic)
{
   int _CountOrd;
   _CountOrd=0;
   for(int i=0;i<OrdersTotal();i++)
   {
      OrderSelect(i,SELECT_BY_POS,MODE_TRADES);
      if(OrderSymbol()==Symbol())
      {
         if((OrderType()==Type&&(OrderMagicNumber()==Magic)||Magic==0))_CountOrd++;
      }
   }
   return(_CountOrd);
}




//|---------allow one action per bar

bool NewBarBuy()
{
   if(PreviousBarTime1<Time[0])
   {
      PreviousBarTime1=Time[0];
      return(true);
   }
   return(false);
}

bool NewBarSell()
{
   if(PreviousBarTime2<Time[0])
   {
      PreviousBarTime2=Time[0];
      return(true);
   }
   return(false);
}

//|---------calculate money management

void CalculateMM()
{
   double MinLots=MarketInfo(Symbol(),MODE_MINLOT);
   double MaxLots=MarketInfo(Symbol(),MODE_MAXLOT);
   Lotsize=AccountFreeMargin()/100000*RiskPercent;
   Lotsize=MathMin(MaxLots,MathMax(MinLots,Lotsize));
   if(MinLots<0.1)Lotsize=NormalizeDouble(Lotsize,2);
   else
   {
     if(MinLots<1)Lotsize=NormalizeDouble(Lotsize,1);
     else Lotsize=NormalizeDouble(Lotsize,0);
   }
   if(Lotsize<MinLots)Lotsize=MinLots;
   if(Lotsize>MaxLots)Lotsize=MaxLots;
 
}



void trailingStopManager(int tsV, bool profits,bool enableTS){
   
   double pointer, bidder, asker;
   
   if (enableTS == true){
   
      for(int cnt=0;cnt<OrdersTotal();cnt++){
   
         OrderSelect(cnt, SELECT_BY_POS, MODE_TRADES);

         if ((tsV>0) && (Symbol() == OrderSymbol()) && (OrderMagicNumber() == Magic)){
      
            bidder  = MarketInfo(OrderSymbol(),MODE_BID);
            asker   = MarketInfo(OrderSymbol(),MODE_ASK);
            pointer = MarketInfo(OrderSymbol(),MODE_POINT);
         
            if (OrderType()==OP_BUY){
               if ((bidder-OrderOpenPrice()>pointer*tsV) || profits==false){
                  if (OrderStopLoss()<bidder-pointer*tsV){
                     OrderModify(OrderTicket(),OrderOpenPrice(),bidder-pointer*tsV,OrderTakeProfit(),0,Green); 
                  }
               }
            }
            else if (OrderType()==OP_SELL){
               if ((OrderOpenPrice()-asker>pointer*tsV) || profits==false){
                  if ((OrderStopLoss()>(asker+pointer*tsV)) || (OrderStopLoss()==0)){
                     OrderModify(OrderTicket(),OrderOpenPrice(),asker+pointer*tsV,OrderTakeProfit(),0,Red); 
                  }
               }
            }
         }//tsV  
      }//for 
      
   }
   

}
